data TEST;
   /* Set values for testing */
   DT='26JUN12:17:00:00'dt;
   FORMAT DT DATETIME. NEWDATE DATETIME.;
   ZONE=-5;
   year=year((datepart(dt)));
   day1=mdy(1,1,year);
   /* Year <=2006 DST starts 1st SUN in April, ends last SUN in October */
   if year <= 2006 then do;
      dst_month_start=intnx('month',day1,3);
      dst_beg=intnx('week.1',dst_month_start,(weekday(dst_month_start) ne 1));
      dst_month_end=intnx('month',day1,9);
      dst_end=intnx('week.1',dst_month_end,(weekday(dst_month_end) in (6,7))+4);
   end;
   /* Year >2006 DST starts 2nd SUN in March, ends 1st SUN in November. */
   else do;  
      dst_month_start=intnx('month',day1,2);
      dst_beg=intnx('week.1',dst_month_start, (weekday(dst_month_start) in (2,3,4,5,6,7))+1);
      dst_month_end=intnx('month',day1,10);
      dst_end=intnx('week.1',dst_month_end,(weekday(dst_month_end) ne 1));
   end;
   NEWDATE=dt+(zone*60*60);
   if dst_beg<=datepart(dt)<=dst_end then NEWDATE=NEWDATE+(3600);
   putlog _all_;
run;
